module hack_atoms_mod

    integer, parameter :: UNIT = 66
    integer :: natoms, hack_atoms_period, hack_atoms_counter
    logical :: defined = .false.
    integer, dimension(:), allocatable :: atoms

    real*8, dimension(:,:), allocatable :: xyz

    public :: hack_atoms_init, hack_atoms_write, hack_atoms_counter, hack_atoms_period
    character*80 :: frmt

contains

    subroutine hack_atoms_init()
    
        open(unit=UNIT, file="HACK_ATOMS", status="old")
        read(UNIT,*) natoms, hack_atoms_period
        allocate(atoms(natoms), xyz(3,natoms))
        write(frmt,*) natoms*3
        frmt = "("//trim(adjustl(frmt))//"F12.5)"
        read(UNIT,*) atoms
        close(UNIT)
        open(unit=UNIT, file="HACK_ATOMS.out", status="replace")
        defined = .true.
        hack_atoms_counter = 0

    end subroutine hack_atoms_init


    subroutine hack_atoms_write(x)

        real*8, dimension(:,:), intent(in) :: x

        integer :: i

        if (.not. defined) return

        do i = 1, natoms
            xyz(:,i) = x(:,atoms(i))
        end do
        write(UNIT,frmt) xyz
        flush(UNIT)

    end subroutine hack_atoms_write


end module hack_atoms_mod
